with minfr.Debug;
use minfr.Debug;

package body minfr.Condition.Condition_Event is


   function Constr_Condition_Event (data : P_MinFr_Data; Event_Type : string; buffered : boolean)return Ptr_Condition_Event is
   begin
      return Tmp : Ptr_Condition_Event do
         Tmp := new Condition_Event;
         Tmp.data := data;
         Tmp.Event_Type := to_unbounded_string(Event_Type);
         Tmp.buffered := buffered;
         Tmp.data.Subscribe_To_Event_Msg(Event_Type,LastTable_Id(tmp.Subs_Id));
         Tmp.Msg := Constr_Minfr_Msg("Msg");
      end return;
   end Constr_Condition_Event;

   function Get_Name (this : Condition_Event) return String is
   begin
      return To_String(this.Event_Type);
   end Get_Name;



   function Evaluate_Condition (this : Condition_Event) return boolean is
      resp : boolean := false;
      debug : boolean := false;
      --msg : Ptr_Minfr_Msg:= Constr_Minfr_Msg("Msg");
   begin

      print(debug,"Condition_Event--Evaluate_Condition--");
      if this.data.Has_Event_Msg (to_string(this.Event_Type),LastTable_Id(this.Subs_Id)) then
         print(debug,"Condition_Event--Evaluate_Condition--this.data.Has_Event_Msg--True");
         if this.buffered then
            print(debug,"Condition_Event--Evaluate_Condition--this.buffered--True");
            msg.all := this.data.Pop_Event_Msg(to_string(this.Event_Type),LastTable_Id(this.Subs_Id));
         else
            print(debug,"Condition_Event--Evaluate_Condition--this.buffered--false--this.data.Pop_UntilLast_Event_Msg("& to_string(this.Event_Type) & "," & LastTable_Id'Image(LastTable_Id(this.Subs_Id))& ")");
            msg.all := this.data.Pop_UntilLast_Event_Msg(to_string(this.Event_Type),LastTable_Id(this.Subs_Id));
         end if;
      resp := true;
      end if;
      print(debug,"Condition_Event--Evaluate_Condition--return " & boolean'Image(resp));
      return resp;

      exception
      when others =>
         print(true,"Condition_Event--Evaluate_Condition--" & this.Get_Name &"--exception");
         delay 10.00;
         return true;
      --???????  en c++ no devuelve nada para Pop_Event_Msg y Pop_UntilLast_Event_Msg
   end Evaluate_Condition;

end minfr.Condition.Condition_Event;
