with Ada.Strings.Unbounded,
     Minfr.MinFr_Component_Data.MinFr_Data,
     Minfr.MSG.Minfr_Msg;


use Ada.Strings.Unbounded,
    Minfr.MinFr_Component_Data.MinFr_Data,
    Minfr.MSG.Minfr_Msg;

package minfr.Condition.Condition_Event is

type Type_Cst_Event is new Natural;

   type Condition_Event (<>) is new Condition with private;
   type Ptr_Condition_Event is access Condition_Event;

   not overriding
   function Constr_Condition_Event (data : P_MinFr_Data; Event_Type : string; buffered : boolean)return Ptr_Condition_Event;
   not overriding
   function Get_Name (this : Condition_Event) return String;
   overriding
   function Evaluate_Condition (this : Condition_Event) return boolean;



private

   debug : boolean := false;
   msg : Ptr_Minfr_Msg:= Constr_Minfr_Msg("Msg");

   type Condition_Event is new Condition with record
      Event_Type : Unbounded_string :=Null_Unbounded_String; --Ristra de longitud Dinamica;
      Subs_Id : Type_Cst_Event;
      data : P_MinFr_Data;
      Last_Msg_Sec_Num : Type_Cst_Event;
      buffered : boolean;
      msg : Ptr_Minfr_Msg;
   end record;


end minfr.Condition.Condition_Event;
