package body minfr.Condition.Condition_Port is


   function Constr_Condition_Port(data : P_MinFr_Data; port : string; msgName : string; buffered : boolean)return Ptr_Condition_Port is
   begin
      return Tmp : Ptr_Condition_Port do
         Tmp := new Condition_Port;
         Tmp.data := data;
         Tmp.port := to_unbounded_string(port);
         tmp.buffered := buffered;
         Tmp.data.Subscribe_To_InPort_Msg(port,LastTable_Id(Tmp.Subs_Id));
         Tmp.Msg_Name := to_unbounded_string(msgName);
      end return;
   end Constr_Condition_Port;

   function Evaluate_Condition (this : Condition_Port) return boolean is
      resp : boolean := false;
      msg : Ptr_Minfr_Msg:= Constr_Minfr_Msg("Msg");
   begin
      if this.data.Has_InPort_Msg(to_string(this.port),LastTable_Id(this.Subs_Id)) then
         if this.buffered then
            null;---Aqui es donde tengo que mirar si tengo algun mensaje enviarlo
         else
            msg.all := this.data.Pop_UntilLast_InPort_Msg(to_string(this.port),LastTable_Id(this.Subs_Id));
         end if;
      end if;

      if msg.Get_Name = to_string(this.Msg_Name)  then
         resp := true;
      end if;

      return resp;
   end Evaluate_Condition;

end minfr.Condition.Condition_Port;
