with Ada.Strings.Unbounded,
     Minfr.MinFr_Component_Data.MinFr_Data,
     Minfr.MSG.Minfr_Msg;

use Ada.Strings.Unbounded,
    Minfr.MinFr_Component_Data.MinFr_Data,
    Minfr.MSG.Minfr_Msg;

package minfr.Condition.Condition_Port is

type Type_CstPort is new Natural;

   type Condition_Port (<>) is new Condition with private;
   type Ptr_Condition_Port is access Condition_Port;

   not overriding
   function Constr_Condition_Port(data : P_MinFr_Data; port : string; msgName : string; buffered : boolean)return Ptr_Condition_Port;
   overriding
   function Evaluate_Condition (this : Condition_Port) return boolean;


private

   type Condition_Port is new Condition with record
      port : Unbounded_string :=Null_Unbounded_String; --Ristra de longitud Dinamica;
      Subs_Id : Type_CstPort;
      data : P_MinFr_Data;
      Last_Port_Msg_Sec : Type_CstPort;
      Msg_Name : Unbounded_string :=Null_Unbounded_String; --Ristra de longitud Dinamica;
      buffered : boolean;
   end record;


end minfr.Condition.Condition_Port;
