package body minfr.Debug is

--     task body Task_debug is -- cuerpo de la tarea
--        str : string := " ";
--     begin
--        loop
--          print(true,"Selecione obcion :");
--           str := Get_keys(true);
--           print(true,"Str : " & str);
--           if str = "1" then
--              print(true,"Debug 1");
--              debug1 := true;
--           end if;
--           if str = "2" then
--              print(true,"Debug 2");
--              debug2 := true;
--           end if;
--           if str = "3" then
--              print(true,"Debug 3");
--              debug3 := true;
--           end if;
--           if str = "4" then
--              print(true,"Debug 4");
--              debug4 := true;
--           end if;
--           if str = "0" then
--              print(true,"Debug 0");
--              debug1 := false;
--              debug2 := false;
--              debug3 := false;
--              debug4 := false;
--           end if;
--        end loop;
--
--     end Task_debug;

   Procedure print (bool : boolean;str : string) is
   begin
      if bool then
         put(str);
         new_line;
      end if;
      exception
      when others =>
         put("Debug--print--exception");
   end print;

   Procedure print_Fichero (Fichero,str : string; sel : natural) is
   begin
      Protec_Debug_Data.Protec_print_Fichero(Fichero,str,sel);
   end print_Fichero;

   Procedure Close_Fichero (Fichero : string)is
   begin
      Protec_Debug_Data.Protec_Close_Fichero(Fichero);
   end Close_Fichero;

   Procedure print_Pulse (bool : boolean;str : string) is
   begin
      if bool then
         put(str);
         new_line;
         Pulse_key(bool);
      end if;
      exception
      when others =>
         put("Debug--print_Pulse--exception");
   end print_Pulse;


   Procedure Pulse_key (bool : boolean) is
      Tecla : string := " ";
   begin
      if bool then
         Put_Line("Puese una Tecla");
         Get(Tecla);
      end if;
      exception
      when others =>
         put("Debug--Pulse_key--exception");

   end Pulse_key;

   function Get_keys (bool : boolean) return string is
      Tecla : string := " ";
   begin
      if bool then
         Get(Tecla);
      end if;
      return Tecla;
      exception
      when others =>
         put("Debug--Pulse_key--exception");
         return Tecla;
   end Get_keys;


   Procedure Loop_TA is
      Debug : Boolean := True;
   begin
      print(Debug,"Debug--Loop_TA--Star");
      Pulse_key(Debug);
      Protec_Debug_Data.Debug_Stop_TA;
      if Protec_Debug_Data.Debug_Read_TB then
         print(Debug,"Debug--Loop_TA--Bool_TB := True");
         Pulse_key(Debug);
         Protec_Debug_Data.Debug_Star_TB;
      end if;
      Bucle_TA:
      loop
         exit Bucle_TA when Protec_Debug_Data.Debug_Read_TA = False;
      end loop Bucle_TA;
      print(Debug,"Debug--Loop_TA--End");
      Pulse_key(Debug);
   end Loop_TA;

   Procedure Loop_TB is
      Debug : Boolean := True;
   begin
      print(Debug,"Debug--Loop_TB");
      Pulse_key(Debug);
      Protec_Debug_Data.Debug_Stop_TB;
      if Protec_Debug_Data.Debug_Read_TA then
         print(Debug,"Debug--Loop_TA--Bool_TA := True");
         Pulse_key(Debug);
         Protec_Debug_Data.Debug_Star_TA;
      end if;
      Bucle_TB:
      loop
         exit Bucle_TB when Protec_Debug_Data.Debug_Read_TB = False;
      end loop Bucle_TB;
      print(Debug,"Debug--Loop_TB--End");
      Pulse_key(Debug);
   end Loop_TB;

   Procedure Star_TA is
   begin
      Protec_Debug_Data.Debug_Star_TA;
   end Star_TA;

   Procedure Star_TB is
   begin
      Protec_Debug_Data.Debug_Star_TB;
   end Star_TB;


   protected body Protec_Debug is

      procedure Debug_Stop_TA is
      begin
         Bool_TA := true;
      end Debug_Stop_TA;

      procedure Debug_Stop_TB is
      begin
          Bool_TB := true;
      end Debug_Stop_TB;

      procedure Debug_Star_TA is
      begin
         Bool_TA := False;
      end Debug_Star_TA;

      procedure Debug_Star_TB is
      begin
         Bool_TB := False;
      end Debug_Star_TB;

      function  Debug_Read_TA return Boolean is
      begin
         return Bool_TA;
      end Debug_Read_TA;

      function  Debug_Read_TB return Boolean is
      begin
         return Bool_TB;
      end Debug_Read_TB;

      Procedure Protec_print_Fichero (Fichero,str : string; sel : natural) is
         Tem_Ficheros : Ficheros;
         Idem : Type_Vec_Fichero.Cursor;
         Tem_Bool : boolean := false;
      begin
         Idem := Map_Fichero.Find(Fichero);
         if Idem /= Type_Vec_Fichero.No_Element then
            Tem_Ficheros := Element(Idem);
            if Is_Open(Fich(Tem_Ficheros.N_Fich)) then
               if sel = 0 then
                  Put(Fich(Tem_Ficheros.N_Fich),str);
                  New_Line(Fich(Tem_Ficheros.N_Fich));
               end if;
               if sel = 1 then
                  Put(Fich(Tem_Ficheros.N_Fich),str & ", ");
               end if;
            end if;
         else
            if N_Fich < 50 then
               Tem_Ficheros.N_Nombre := Fichero'Length;
               Tem_Ficheros.N_Fich := N_Fich;
               Tem_Ficheros.Nombre(1..Tem_Ficheros.N_Nombre) := Fichero (1..Tem_Ficheros.N_Nombre);
               Tem_Ficheros.bool := true;
               Create(Fich(Tem_Ficheros.N_Fich),Out_File,Tem_Ficheros.Nombre(1..Tem_Ficheros.N_Nombre));
               if sel = 0 then
                  Put(Fich(Tem_Ficheros.N_Fich),str);
                  New_Line(Fich(Tem_Ficheros.N_Fich));
               end if;
                if sel = 1 then
                  Put(Fich(Tem_Ficheros.N_Fich),str & ", ");
               end if;
               Map_Fichero.Insert(Fichero,Tem_Ficheros,Idem,Tem_Bool);
               N_Fich := N_Fich+1;
            end if;
         end if;
      end Protec_print_Fichero;

      Procedure Protec_Close_Fichero (Fichero : string) is
         Tem_Ficheros : Ficheros;
         Idem : Type_Vec_Fichero.Cursor;
      begin
         Idem := Map_Fichero.Find(Fichero);
         if Idem /= Type_Vec_Fichero.No_Element then
            Tem_Ficheros := Element(Idem);
            Close(Fich(Tem_Ficheros.N_Fich));
         end if;
      end Protec_Close_Fichero;


   end Protec_Debug;

end minfr.Debug;
