with MinFr.Debug,
     Ada.Real_Time,
     Ada.Task_Identification,
     Ada.Execution_Time,
     Ada.Text_IO;

use MinFr.Debug,
    Ada.Real_Time,
     Ada.Task_Identification,
    Ada.Execution_Time,
    Ada.Text_IO;

procedure minfr.Main is




   task A is
       entry Start;
   end A; -- especificacin de la tarea

   task B is
      entry Start;
   end B; -- especificacin de la tarea



   task body A is -- cuerpo de la tarea
      Time_A_1 : CPU_Time;
      Time_A_2 : CPU_Time;
      Segundos : Seconds_Count := 2;
      TS : Time_Span;
      Id_Trak_A : Task_Id;
      Timer: Time:= Clock;
   begin
      accept Start;
      Id_Trak_A := Current_Task;
      print (true,"Start-A");
      B.Start;
      loop
         --Time_A_1 := Time_Of(Segundos);
         Time_A_1 := Clock(Id_Trak_A);
         print (true,"Loop-A");
         delay until Timer;
         Time_A_2 := Clock(Id_Trak_A);
         TS := Time_A_2-Time_A_1;
         Timer := Timer + Seconds(10);
         print (true,"Tiempo A :" & integer'Image(integer(To_Duration(TS *1000000000))));
      end loop;
   end A;

   task body B is -- cuerpo de la tarea

   begin
      accept Start;
      print (true,"Start-B");
      loop
         print (true,"Loop-B");
         delay(2.5);
      end loop;
   end B;

   Fich : File_Type;
   --Nombre : String(1..20);
   --N_Nombre : Integer range 0..20;
begin
   print (true,"Inicio");
   print_Fichero("dato.txt","Hola");
   print_Fichero("dato.txt","Hola1");
   print_Fichero("dato.txt","Hola2");
   print_Fichero("dato.txt","Hola3");
   print_Fichero("dato1.txt","Hola1_1");
   print_Fichero("dato1.txt","Hola1_2");
   Close_Fichero("dato.txt");
   Close_Fichero("dato1.txt");

   --A.Start;

end minfr.Main;
