with Ada.Text_IO,
     minfr.Debug,
     Minfr.MinFr_Component_Data.MinFr_Data,
     Minfr.MinFr_Port,
     Minfr.Minfr_State.Leaf_State,
     Minfr.Transition,
     Minfr.Condition,
     Minfr.Condition.Condition_Event,
     Minfr.MinFr_Component,
     Minfr.MinFr_Component.Component,
     Minfr.MinFr_Component_Data,
     Minfr.State_Activity,
     Minfr.State_Activity.Leaf_Activity.Cmd_Up_date,
     Minfr.State_Activity.Leaf_Activity.State_Start_C1_R2,
     Minfr.State_Activity.Leaf_Activity.State_Loop_C1_R2,
     Minfr.State_Activity.Leaf_Activity.State_Loop_C2_R2,
     Minfr.Activity_Processor,
     Minfr.Minfr_State,
     Minfr.Minfr_State.Hierarchical_State,
     Minfr.Minfr_State.Hierarchical_State.Region;

use Ada.Text_IO,
    minfr.Debug,
    Minfr.MinFr_Component_Data.MinFr_Data,
    Minfr.MinFr_Port,
    Minfr.Minfr_State.Leaf_State,
    Minfr.Transition,
    Minfr.Condition,
    Minfr.Condition.Condition_Event,
    Minfr.MinFr_Component,
    Minfr.MinFr_Component.Component,
    Minfr.MinFr_Component_Data,
    Minfr.State_Activity,
    Minfr.State_Activity.Leaf_Activity.Cmd_Up_date,
    Minfr.State_Activity.Leaf_Activity.State_Start_C1_R2,
    Minfr.State_Activity.Leaf_Activity.State_Loop_C1_R2,
    Minfr.State_Activity.Leaf_Activity.State_Loop_C2_R2,
    Minfr.Activity_Processor,
    Minfr.Minfr_State,
    Minfr.Minfr_State.Hierarchical_State,
    Minfr.Minfr_State.Hierarchical_State.Region;

procedure minfr.Main_Caso_Estudio_1 is


   data_1 : P_MinFr_Data :=  Constr_MinFr_Data ("data-C1");
   data_2 : P_MinFr_Data :=  Constr_MinFr_Data ("data-C2");

--Declaracion de vector regiones componete 1
   Vec_State_C1_R1 : Vector_ptr_Minfr_State.Vector;
   Vec_State_C1_R2 : Vector_ptr_Minfr_State.Vector;
--Declaracion de vector regiones componete 1
   Vec_State_C2_R1 : Vector_ptr_Minfr_State.Vector;
   Vec_State_C2_R2 : Vector_ptr_Minfr_State.Vector;

--Declaracion de puertos componete 1
   Port_InA :  Ptr_MinFr_Input_Port := Constr_MinFr_Input_Port(2,1,"InputA",data_1);
   Port_OutA : Ptr_MinFr_OutPut_Port := Constr_MinFr_OutPut_Port(1,1,"OutputA");
--Declaracion de puertos componete 2
   Port_InB :  Ptr_MinFr_Input_Port := Constr_MinFr_Input_Port(1,2,"InputB",data_2);
   Port_OutB : Ptr_MinFr_OutPut_Port := Constr_MinFr_OutPut_Port(2,2,"OutputB");

--Delclaracion de Estados Componete 1 Region 1
   State_1_R1_C1 : Ptr_Leaf_State := Constr_Leaf_State (1,"State_1_R1_C1");
--Delclaracion de Estados Componete 1 Region 2
   State_1_R2_C1 : Ptr_Leaf_State := Constr_Leaf_State (2,"State_1_R2_C1");
   State_2_R2_C1 : Ptr_Leaf_State := Constr_Leaf_State (3,"State_2_R2_C1");
--Delclaracion de Estados Componete 2 Region 1
   State_1_R1_C2 : Ptr_Leaf_State := Constr_Leaf_State (1,"State_1_R1_C2");
--Delclaracion de Estados Componete 2 Region 2
   State_1_R2_C2 : Ptr_Leaf_State := Constr_Leaf_State (2,"State_1_R2_C2");

--Declaracion de transiciones Componente 1 Region 1
   Trasicion_State_1_R1_C1 : Ptr_Transition := Constr_Transition("Trasicion_State_1_R1_C1");
--Declaracion de transiciones Componente 1 Region 2
   Trasicion_State_1_R2_C1 : Ptr_Transition := Constr_Transition("Trasicion_State_1_R2_C1");
   Trasicion_State_2_R2_C1 : Ptr_Transition := Constr_Transition("Trasicion_State_2_R1_C1");
--Declaracion de transiciones Componente 2 Region 1
   Trasicion_State_1_R1_C2 : Ptr_Transition := Constr_Transition("Trasicion_State_1_R1_C2");
--Declaracion de transiciones Componente 2 Region 2
   Trasicion_State_1_R2_C2 : Ptr_Transition := Constr_Transition("Trasicion_State_1_R2_C2");

--Declaracion de vectores de condiciones componente 1 Region 1
   Vec_Condi_State_1_R1_C1 : Vector_ptr_Condition.Vector;
--Declaracion de vectores de condiciones componente 1 Region 2
   Vec_Condi_State_1_R2_C1 : Vector_ptr_Condition.Vector;
   Vec_Condi_State_2_R2_C1 : Vector_ptr_Condition.Vector;
--Declaracion de vectores de condiciones componente 2 Region 1
   Vec_Condi_State_1_R1_C2 : Vector_ptr_Condition.Vector;
--Declaracion de vectores de condiciones componente 2 Region 2
   Vec_Condi_State_1_R2_C2 : Vector_ptr_Condition.Vector;

--Declaracion Eventos cambiar de estado componente 1 Region 1
   Condition_Event_St1_1_C1_R1 : Ptr_Condition_Event := Constr_Condition_Event (data_1,"C1-R1-St1-1",false);
--Declaracion Eventos cambiar de estado componente 1 Region 2
   Condition_Event_St1_2_C1_R2 : Ptr_Condition_Event := Constr_Condition_Event (data_1,"C1-R2-St1-2",false);
   Condition_Event_St2_2_C1_R2 : Ptr_Condition_Event := Constr_Condition_Event (data_1,"C1-R2-St2-2",false);
--Declaracion Eventos cambiar de estado componente 2 Region 1
   Condition_Event_St1_1_C2_R1 : Ptr_Condition_Event := Constr_Condition_Event (data_2,"C2-R1-St1-1",false);
--Declaracion Eventos cambiar de estado componente 2 Region 2
   Condition_Event_St1_1_C2_R2 : Ptr_Condition_Event := Constr_Condition_Event (data_2,"C2-R2-St1-1",false);

--Declaracion componente 1
   Componente_1 : Ptr_Component := Constr_Component (1,"Componente_1", Ptr_MinFr_Component_Data(data_1));
--Declaracion componente 2
   Componente_2 : Ptr_Component := Constr_Component (2,"Componente_2", Ptr_MinFr_Component_Data(data_2));


--  --Declaracion estados componente 1 Region 1
--     St_Up_Date_Ports_C1_R1 :Ptr_Up_Date_Ports_C1_R1 := Constr_Up_Date_Ports_C1_R1;
--  --Declaracion estados componente 1 Region 2
--     St_State_Start_C1_R2 :Ptr_State_Start_C1_R2 := Constr_State_Start_C1_R2;
--     St_State_Loop_C1_R2 :Ptr_State_Loop_C1_R2 := Constr_State_Loop_C1_R2;
--  --Declaracion estados componente 2 Region 1
--     St_Up_Date_Ports_C2_R1 :Ptr_Up_Date_Ports_C2_R1 := Constr_Up_Date_Ports_C2_R1;
--  --Declaracion estados componente 2 Region 2
--     St_State_Loop_C2_R2 :Ptr_State_Loop_C2_R2 := Constr_State_Loop_C2_R2;

--Declaracion estados componente 1 Region 1
   St_Up_Date_Ports_C1_R1 : Ptr_Cmd_Up_date;
--Declaracion estados componente 1 Region 2
   St_State_Start_C1_R2 : Ptr_State_Start_C1_R2;
   St_State_Loop_C1_R2 : Ptr_State_Loop_C1_R2;
--Declaracion estados componente 2 Region 1
   St_Up_Date_Ports_C2_R1 : Ptr_Cmd_Up_date;
--Declaracion estados componente 2 Region 2
   St_State_Loop_C2_R2 : Ptr_State_Loop_C2_R2;

--Declaracion actividades componente 1 Region 1
   Activity_C1 : Ptr_Activity_Processor := Constr_Activity_Processor;
--Declaracion actividades componente 2 Region 1
   Activity_C2 : Ptr_Activity_Processor := Constr_Activity_Processor;

--Declaracion Actividades gerarquicas componente 1
   HA_C1_R1 : Ptr_Hierarchical_Activity;
   HA_C1_R2 : Ptr_Hierarchical_Activity;
--Declaracion Actividades gerarquicas componente 1
   HA_C2_R1 : Ptr_Hierarchical_Activity;
   HA_C2_R2 : Ptr_Hierarchical_Activity;

--Declaracion Regiones componente 1
   Region_1_C_1 : Ptr_Region;
   Region_2_C_1 : Ptr_Region;
--Declaracion Regiones componente 2
   Region_1_C_2 : Ptr_Region;
   Region_2_C_2 : Ptr_Region;

--
     Id : LastTable_Id:=0;
   --     --msg : Ptr_Minfr_Msg := Constr_Minfr_Msg;
   bool : boolean := false;

begin


                                                                      --Trak A                Trak B
                                                                     -----------|   <--    |-----------
   Port_OutA.Set_Conjugate(Ptr_MinFr_Port(Port_InB));                --    OA --|--> -- >--|-- IB
                                                                     --    IA --|--< -- <--|-- OB
   Port_OutB.Set_Conjugate(Ptr_MinFr_Port(Port_InA));	    	     -----------|    -->   |-----------


   print(true,"Definicion buffer entrada y salida");
--Definicion buffer entrada y salida
   data_1.Subscribe_To_InPort_Msg(Port_InA.Get_Name,Id);
   data_1.Create_OutPort_Buffer(Port_OutA.Get_Name, bool);
   data_2.Subscribe_To_InPort_Msg(Port_InB.Get_Name,Id);
   data_2.Create_OutPort_Buffer(Port_OutB.Get_Name, bool);

   print(true,"Agregamos los puertos a cada componente");
--Agregamos los puertos a cada componente
   Componente_1.Add_Port(Ptr_MinFr_Port(Port_InA));
   Componente_1.Add_Port(Ptr_MinFr_Port(Port_OutA));
   Componente_2.Add_Port(Ptr_MinFr_Port(Port_InB));
   Componente_2.Add_Port(Ptr_MinFr_Port(Port_OutB));

--Agregamos las Regiones a cada componente
   --Componente_1.Add_Region(Ptr_Hierarchical_State(Region_1_C_1));
   --Componente_1.Add_Region(Ptr_Hierarchical_State(Region_2_C_1));
   --Componente_2.Add_Region(Ptr_Hierarchical_State(Region_1_C_2));
   --Componente_2.Add_Region(Ptr_Hierarchical_State(Region_2_C_2));

   print(true,"Construimos los estados");
   --Construimos los estados
   St_Up_Date_Ports_C1_R1 := Constr_Cmd_Up_date (1,Ptr_MinFr_Component(Componente_1),Ptr_MinFr_Component_Data(data_1));
   St_State_Start_C1_R2 := Constr_State_Start_C1_R2(2,Ptr_MinFr_Component(Componente_1));
   St_State_Loop_C1_R2 := Constr_State_Loop_C1_R2 (3,Ptr_MinFr_Component(Componente_1));
   St_Up_Date_Ports_C2_R1 := Constr_Cmd_Up_date (4,Ptr_MinFr_Component(Componente_2),Ptr_MinFr_Component_Data(data_2));
   St_State_Loop_C2_R2 := Constr_State_Loop_C2_R2(5,Ptr_MinFr_Component(Componente_2));

   print(true,"Montamos el estado Up_Date_Ports_C1_R1");
--Montamos el estado Up_Date_Ports_C1_R1
   St_Up_Date_Ports_C1_R1.Set_Name("St_Up_Date_Ports_C1_R1");
   --Vec_Condi_State_1_R1_C1.Append(Ptr_Condition(Condition_Event_St1_1_C1_R1));
   --Trasicion_State_1_R1_C1.Add_Conditions(Vec_Condi_State_1_R1_C1);
  -- Trasicion_State_1_R1_C1.Set_State(State_Id(State_1_R1_C1.Get_Id));
   State_1_R1_C1.Set_Activity(Ptr_State_Activity(St_Up_Date_Ports_C1_R1));
   --State_1_R1_C1.Add_Transition(Trasicion_State_1_R1_C1);

   print(true,"Montamos el estado State_Start_C1_R2");
--Montamos el estado State_Start_C1_R2
   St_State_Start_C1_R2.Set_Name("St_State_Start_C1_R2");
   Vec_Condi_State_1_R2_C1.Append(Ptr_Condition(Condition_Event_St1_2_C1_R2));
   Trasicion_State_1_R2_C1.Add_Conditions(Vec_Condi_State_1_R2_C1);
   Trasicion_State_1_R2_C1.Set_State(State_Id(State_2_R2_C1.Get_Id)); -- Indicamos la transicion que tiene que ir
   State_1_R2_C1.Set_Activity(Ptr_State_Activity(St_State_Start_C1_R2));
   State_1_R2_C1.Add_Transition(Trasicion_State_1_R2_C1);

  print(true,"Montamos el estado State_Loop_C1_R2");
--Montamos el estado State_Loop_C1_R2
   St_State_Loop_C1_R2.Set_Name("St_State_Loop_C1_R2");
   Vec_Condi_State_2_R2_C1.Append(Ptr_Condition(Condition_Event_St2_2_C1_R2));
   Trasicion_State_2_R2_C1.Add_Conditions(Vec_Condi_State_2_R2_C1);
   Trasicion_State_2_R2_C1.Set_State(State_Id(State_2_R2_C1.Get_Id)); -- Indicamos la transicion que tiene que ir
   State_2_R2_C1.Set_Activity(Ptr_State_Activity(St_State_Loop_C1_R2));
   State_2_R2_C1.Add_Transition(Trasicion_State_2_R2_C1);

  print(true,"Montamos el estado Up_Date_Ports_C2_R1");
--Montamos el estado Up_Date_Ports_C2_R1
   St_Up_Date_Ports_C2_R1.Set_Name("St_Up_Date_Ports_C2_R1");
   --Vec_Condi_State_1_R1_C2.Append(Ptr_Condition(Condition_Event_St1_1_C2_R1));
   --Trasicion_State_1_R1_C2.Add_Conditions(Vec_Condi_State_1_R1_C2);
   --Trasicion_State_1_R1_C2.Set_State(State_Id(State_1_R1_C2.Get_Id));
   State_1_R1_C2.Set_Activity(Ptr_State_Activity(St_Up_Date_Ports_C2_R1));
   --State_1_R1_C2.Add_Transition(Trasicion_State_1_R1_C2);

  print(true,"Montamos el estado State_Loop_C2_R2");
--Montamos el estado State_Loop_C2_R2
   St_State_Loop_C2_R2.Set_Name("St_State_Loop_C2_R2");
   Vec_Condi_State_1_R2_C2.Append(Ptr_Condition(Condition_Event_St1_1_C2_R2));
   Trasicion_State_1_R2_C2.Add_Conditions(Vec_Condi_State_1_R2_C2);
   Trasicion_State_1_R2_C2.Set_State(State_Id(State_1_R2_C2.Get_Id)); -- Indicamos la transicion que tiene que ir
   State_1_R2_C2.Set_Activity(Ptr_State_Activity(St_State_Loop_C2_R2));
   State_1_R2_C2.Add_Transition(Trasicion_State_1_R2_C2);

  print(true,"Montamos la region 1 del componente 1");
--Montamos la region 1 del componente 1
   Vec_State_C1_R1.Append(Minfr_State_Ptr(State_1_R1_C1));
   Region_1_C_1 := Constr_Region(data_1,"Region_1_C_1",Vec_State_C1_R1,1,1);
   HA_C1_R1 := Cont_Hierarchical_Activity(Ptr_Hierarchical_State(Region_1_C_1));
   HA_C1_R1.Set_Name("Hierachical-Activity-Region1-Componente1");
   HA_C1_R1.Set_Id(1);
   HA_C1_R1.Set_Period(10);

  print(true,"Montamos la region 2 del componente 1");
--Montamos la region 2 del componente 1
   Vec_State_C1_R2.Append(Minfr_State_Ptr(State_1_R2_C1));
   Vec_State_C1_R2.Append(Minfr_State_Ptr(State_2_R2_C1));
   Region_2_C_1 := Constr_Region(data_1,"Region_2_C_1",Vec_State_C1_R2,2,1);
   HA_C1_R2 := Cont_Hierarchical_Activity(Ptr_Hierarchical_State(Region_2_C_1));
   HA_C1_R2.Set_Name("Hierachical-Activity-Region2-Componente1");
   HA_C1_R2.Set_Id(2);
   HA_C1_R2.Set_Period(10);

  print(true,"Montamos la region 1 del componente 2");
--Montamos la region 1 del componente 2
   Vec_State_C2_R1.Append(Minfr_State_Ptr(State_1_R1_C2));
   Region_1_C_2 := Constr_Region(data_2,"Region_1_C_2",Vec_State_C2_R1,1,2);
   HA_C2_R1 := Cont_Hierarchical_Activity(Ptr_Hierarchical_State(Region_1_C_2));
   HA_C2_R1.Set_Name("Hierachical-Activity-Region1-Componente2");
   HA_C2_R1.Set_Id(3);
   HA_C2_R1.Set_Period(10);

  print(true,"Montamos la region 2 del componente 2");
--Montamos la region 2 del componente 2
   Vec_State_C2_R2.Append(Minfr_State_Ptr(State_1_R2_C2));
   Region_2_C_2 := Constr_Region(data_2,"Region_2_C_2",Vec_State_C2_R2,2,2);
   HA_C2_R2 := Cont_Hierarchical_Activity(Ptr_Hierarchical_State(Region_2_C_2));
   HA_C2_R2.Set_Name("Hierachical-Activity-Region2-Componente2");
   HA_C2_R2.Set_Id(4);
   HA_C2_R2.Set_Period(10);

   print(true,"Agregamos las Regiones a cada componente");
 --Agregamos las Regiones a cada componente
   Componente_1.Add_Region(Ptr_Hierarchical_State(Region_1_C_1));
   Componente_1.Add_Region(Ptr_Hierarchical_State(Region_2_C_1));
   Componente_2.Add_Region(Ptr_Hierarchical_State(Region_1_C_2));
   Componente_2.Add_Region(Ptr_Hierarchical_State(Region_2_C_2));

  print(true,"Agregamos las regiones al componente 1");
--Agregamos las regiones al componente 1
   Activity_C1.Add_Activity(Ptr_State_Activity(HA_C1_R1));
   Activity_C1.Add_Activity(Ptr_State_Activity(HA_C1_R2));
   Activity_C1.Set_Name("Activity-Componente1");

  print(true,"Agregamos las regiones al componente 2");
--Agregamos las regiones al componente 2
   Activity_C2.Add_Activity(Ptr_State_Activity(HA_C2_R1));
   Activity_C2.Add_Activity(Ptr_State_Activity(HA_C2_R2));
   Activity_C2.Set_Name("Activity-Componente2");

  print(true,"Ejecutamos las actividades");
--Ejecutamos las actividades
   Activity_C1.Start(Activity_C1);
   Activity_C2.Start(Activity_C2);


end minfr.Main_Caso_Estudio_1;
