with minfr.Debug,
     Ada.Exceptions;

use minfr.Debug,
    Ada.Exceptions;

package body minfr.MSG is

--     function Constr_Msg return access Msg is
--     begin
--        return tmp : access Msg do
--           tmp:=new Msg;
--        end return;
--     end Constr_Msg;

--     function Constr_Msg (msg_Type : string) return access Msg is
--     begin
--        return tmp : access Msg do
--           tmp:=new Msg;
--           tmp.all.msg_type := to_unbounded_string(msg_Type);
--          end return;
--     end Constr_Msg;


   procedure set_Msg_Type(this:in out Msg;str : string) is

   begin
      this.msg_type :=to_unbounded_string(str);
   exception
      when Error: others =>
         print(true,"Msg--set_Msg_Type--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end set_Msg_Type;

   procedure set_Value(this:in out Msg;Key,value:string) is
      C : Tabla.Cursor;
      Ins : Boolean;
   begin
      this.msg.Insert(key,Value, C, Ins);
      if not Ins then
         This.Msg.Replace_Element(C, Value);
      end if;
   exception
      when Error: others =>
         print(true,"Msg--set_Value--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end set_Value;

   procedure UpDate_Value(this:in out Msg;Key,value:String;Res :in out Boolean) is
      C : Tabla.Cursor;
   begin
      Res := False;
      C := this.Msg.Find(Key);
      if C /= Tabla.No_Element then
         This.Msg.Replace_Element(C, Value);
         Res := True;
      end if;
   exception
      when Error: others =>
         print(true,"Msg--UpDate_Value--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end UpDate_Value;


   ---

   function get_Msg_Type (this:in Msg) return string is
   begin
      return to_string(this.msg_type);
   exception
      when Error: others =>
         print(true,"Msg--get_Msg_Type--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return to_string(this.msg_type);

   end get_Msg_Type;

   function get_Value(this:in Msg;Key:string) return string is
      value : string := "0";
      C: tabla.Cursor;
   begin
      print(Debug,"Msg--get_Value--Find(key) :=" & Key);
      C := this.msg.Find(key);

      if C = tabla.No_Element then
         print(debug,"Msg--get_Value--No_Element");
         return "0";
      else
         print(debug,"Msg--get_Value--there's Element");
         return Element(C);-- no such item
      end if;

     exception
      when Error: others =>
         print(true,"Msg--get_Value--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return value;
   end get_Value;


end minfr.MSG;
