with minfr.Debug,
     Ada.Exceptions;
use minfr.Debug,
    Ada.Exceptions;

package body minfr.MSG.Minfr_Msg is

   function Constr_Minfr_Msg return Ptr_Minfr_Msg is
   begin
      return tmp : Ptr_Minfr_Msg do --Indicamos que es un putero de Minfr_Msg
         tmp:=new Minfr_Msg;  --Indicamos a la direcion que apunta
         Tmp.Set_Init_Values("");
      end return;

   exception
      when Error: others =>
         print(true,"Minfr_Msg--Constr_Minfr_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return new Minfr_Msg;
   end Constr_Minfr_Msg;

   function Constr_Minfr_Msg (Name_Type : string) return Ptr_Minfr_Msg is
   begin
      return tmp : Ptr_Minfr_Msg do
         tmp:=new Minfr_Msg;
         Tmp.all.Set_Init_Values(Name_Type); --Cual es la forma correcta "all" o sin "all"
      end return;
   exception
      when Error: others =>
         print(true,"Minfr_Msg--Constr_Minfr_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return new Minfr_Msg;

   end Constr_Minfr_Msg;
 --++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   -- DAC: este constructor no tiene sentido ya que msg es abstracta
   --MinfrMsg::MinfrMsg(MSG msg):MSG(msg.toString()){ En C++ hace esto
    --setMsgType("MinfrMsg");
    --}

   function Constr_Minfr_Msg (msg_Type : msg) return Ptr_Minfr_Msg is
   begin
      return tmp : Ptr_Minfr_Msg do
         tmp:=new Minfr_Msg;
         Tmp.all.Set_Msg_Type(Minifr_Msg_Name); -- Con "all"?????????????????
      end return;

   exception
      when Error: others =>
         print(true,"Minfr_Msg--Constr_Minfr_Msg--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return new Minfr_Msg;

   end Constr_Minfr_Msg;
   --+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


   function Get_Origin_Id (this:in Minfr_Msg) return O_Port_Id is
   begin
      return tmp : O_Port_Id do
         tmp := O_Port_ID'Value(this.get_Value(O_PortId_Name));
      end return;

   exception
      when Error: others =>
         print(true,"Minfr_Msg--Get_Origin_Id--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return 1;
   end Get_Origin_Id;

   procedure Set_Origin_Id(this:in out Minfr_Msg; Port_Id: O_Port_Id) is
   begin
      this.set_Value(Key => O_PortId_Name,value => O_Port_ID'Image(Port_Id));
   exception
      when Error: others =>
         print(true,"Minfr_Msg--Set_Origin_Id--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Set_Origin_Id;

   function Get_Destination_Id (this:in Minfr_Msg) return O_Port_Id is
   begin
      return tmp : O_Port_Id do
         tmp := O_Port_Id'Value(this.get_Value(D_PortId_Name));
      end return;
   exception
      when Error: others =>
         print(true,"Minfr_Msg--Get_Destination_Id--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return O_Port_Id'Value(this.get_Value(D_PortId_Name));
   end Get_Destination_Id;

   procedure Set_Destination_Id(this:in out Minfr_Msg; Port_Id: O_Port_Id) is
   begin
      this.set_Value(Key => D_PortId_Name,value => O_Port_Id'Image(Port_Id));
   exception
      when Error: others =>
         print(true,"Minfr_Msg--Set_Destination_Id--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Set_Destination_Id;

   function Get_Error_Code(this:in Minfr_Msg) return Port_Erro_Code is
      str : string := this.get_Value(ErrorCode_Name);
   begin
      print(debug,"Minfr_Msg--Get_Error_Code");
      Pulse_key(debug);
      return tmp : Port_Erro_Code do
         print(debug,"Minfr_Msg--Get_Error_Code--Str =" & str);
         Pulse_key(debug);
         if str = "0" then
            print(debug,"Minfr_Msg--Get_Error_Code--OK");
            Pulse_key(debug);
            tmp := OK;
         else
            tmp := Port_Erro_Code'Value(str);
            print(debug,"Minfr_Msg--Get_Error_Code--" & Port_Erro_Code'Image(tmp));
            Pulse_key(debug);
         end if;

--           print(debug,"Minfr_Msg--Get_Error_Code--" & str);
--           tmp1 :=  Natural'Value(str);
--           print(debug,"Minfr_Msg:"Natural);
--           delay 20.0;
--
--           print(debug,"Minfr_Msg--Get_Error_Code--return--" & Port_Erro_Code'Image(tmp));
--           delay 20.0;
      end return;

   exception
      when Error: others =>
         print(true,"Minfr_Msg--Get_Error_Code--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return OK;



   end Get_Error_Code;

   procedure Set_Error_Code (this:in out Minfr_Msg; Error_Code: Port_Erro_Code) is
   begin
      this.set_Value(Key => ErrorCode_Name,value => Port_Erro_Code'Image(Error_Code));
   exception
      when Error: others =>
         print(true,"Minfr_Msg--Set_Error_Code--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Set_Error_Code;


   procedure Set_Init_Values(this:in out Minfr_Msg;name :string)is
   begin
      this.set_Msg_Type(Minifr_Msg_Name);
      this.Set_Name(name);
   exception
      when Error: others =>
         print(true,"Minfr_Msg--Set_Init_Values--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Set_Init_Values;


   function Get_Name(this:in Minfr_Msg) return string is
   begin
      return this.get_Value(Key => Name_Name);
   exception
      when Error: others =>
         print(true,"Minfr_Msg--Get_Name--exception : " & Exception_Information(Error));
         Pulse_key(true);
         return this.get_Value(Key => Name_Name);
   end Get_Name;


   procedure Set_Name(this:in out Minfr_Msg;name:string)is
   begin
      this.set_Value(Key => Name_Name,value => name);
   exception
      when Error: others =>
         print(true,"Minfr_Msg--Set_Name--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Set_Name;

end minfr.MSG.Minfr_Msg;
