with Minfr.Msg_aux,
     ada.Unchecked_Deallocation;


use Minfr.Msg_aux;

package minfr.MSG.Minfr_Msg is

   type Minfr_Msg is new Msg with private; --(<>) combierte en un tipo "uncostrained" obligamos que el usuario aceda a las variables con "access" y tiene que llamar al constructor
   type Ptr_Minfr_Msg is access all Minfr_Msg;

   ---------Constructores----------
   not overriding
   function Constr_Minfr_Msg return Ptr_Minfr_Msg;
   not overriding
   function Constr_Minfr_Msg (Name_Type : string) return Ptr_Minfr_Msg;
   not overriding
   function Constr_Minfr_Msg (msg_Type : msg) return Ptr_Minfr_Msg;

--- ++++++++++++terminar retorno de interos construtor

   not overriding
   function Get_Origin_Id (this:in Minfr_Msg) return O_Port_ID;
   not overriding
   procedure Set_Origin_Id (this:in out Minfr_Msg; Port_Id: O_Port_ID);
   not overriding
   function Get_Destination_Id (this:in Minfr_Msg) return O_Port_Id;
   not overriding
   procedure Set_Destination_Id (this:in out Minfr_Msg; Port_Id: O_Port_Id);
   not overriding
   function Get_Error_Code (this:in Minfr_Msg) return Port_Erro_Code;
   not overriding
   procedure Set_Error_Code (this:in out Minfr_Msg; Error_Code: Port_Erro_Code);
   not overriding
   function Get_Name(this:in Minfr_Msg) return string;
   not overriding
   procedure Set_Name(this:in out Minfr_Msg; name:string);

private

   Debug : Boolean := false;

   type Minfr_Msg is new Msg with null record;

   procedure Set_Init_Values(this:in out Minfr_Msg; name :string);

end minfr.MSG.Minfr_Msg;
