with minfr.Debug,
     Ada.Unchecked_Deallocation;



use minfr.Debug;


package body minfr.State_Activity.Leaf_Activity.First_Activity is

   function Constr_First_Activity (Id :Id_State_Activity;Component : Ptr_MinFr_Component) return Ptr_First_Activity is
      tmp1 : Ptr_Leaf_Activity;
   begin
       return Tmp : Ptr_First_Activity do
         Tmp := new First_Activity;
         tmp1 := Ptr_Leaf_Activity(Tmp);
         Constr_Leaf_Activity(Tmp1,Id);
         Tmp.Component := Component;
         Tmp.Data := Component.Get_Component_Data;
         print(true,"First_Activity--Constr_First_Activity");
         Tmp.Port_In := Component.Get_Port_In;
         Tmp.Port_Out := Component.Get_Port_Out;


      end return;
   end Constr_First_Activity;

    ------------------
   -- Execute_Tick --
    ------------------

   --Msg : Ptr_Minfr_Msg:= Constr_Minfr_Msg("Msg");

   procedure Execute_Tick (This :in out First_Activity) is

        Ports : Pack_Orde_Maps_Port.Map;
        Id : LastTable_Id:=0;
        Cont : Natural := 0;
        Bool : Boolean := False;
--
--        --
--        iter : Pack_Orde_Maps_Port.Cursor;

      --procedure Liberar_Msg is new ada.Unchecked_Deallocation (Minfr_Msg,Ptr_Minfr_Msg);


   begin
      print(debug,this.Component.Get_Component_Name &"--First_Activity--" & this.Get_Name &"--Execute_Tick");
      Pulse_key(debug);
      Ports := this.Component.Get_Ports;
      print(debug,"First_Activity--" & this.Get_Name &"--Execute_Tick--Get-Port");
      Pulse_key(debug);

      if This.Port_In = null or This.Port_Out = null then
         print(debug,"First_Activity--" & this.Get_Name &"--Execute_Tick--Port_In = null or Port_Out = null");
         Pulse_key(debug);
      elsif This.Port_Out = null then
         print(debug,"First_Activity--" & this.Get_Name &"--Execute_Tick--Port_Out = null");
         Pulse_key(debug);
      else
         print(debug,"First_Activity--" & this.Get_Name &"--Execute_Tick--OK");
         Pulse_key(debug);
         if this.Data.Has_InPort_Msg(This.Port_In.Get_Name,Id) then
            print(debug,"First_Activity--" & this.Get_Name &"--Execute_Tick--this.Data.Has_InPort_Msg(" & This.Port_In.Get_Name &"," & LastTable_Id'Image(Id) & ")");
            Pulse_key(debug);
            This.Msg.all := this.Data.Pop_InPort_Msg(This.Port_In.Get_Name,Id);
            print(True,this.Component.Get_Component_Name &"--First_Activity--" & this.Get_Name &"--Execute_Tick--Msg.Get_Value = " & This.Msg.Get_Value("Dato"));
            Pulse_key(debug);
            Cont := Natural'Value(This.Msg.Get_Value("Dato"))+1;
            if Cont > 1000 then
               Cont := 0;
            end if;
            print(debug,this.Component.Get_Component_Name &"--First_Activity--" & this.Get_Name &"--Execute_Tick--Cont = " & Natural'Image(Cont));
            Pulse_key(debug);
            This.Msg.UpDate_Value("Dato",Natural'Image(Cont),Bool);
            print(debug,this.Component.Get_Component_Name & "--First_Activity--" & this.Get_Name &"--Execute_Tick--"& This.Port_Out.Get_Name &".UpDate(Msg.all)");
            This.Port_Out.UpDate(This.Msg);
         end if;
         print(debug,"First_Activity--" & this.Get_Name &"--Execute_Tick--this.Data.Has_InPort_Msg(" & This.Port_In.Get_Name &"," & LastTable_Id'Image(Id) & ")--False");
         Pulse_key(debug);
      end if;

      print(debug,this.Component.Get_Component_Name &"--First_Activity--" & this.Get_Name &"--Execute_Tick");
      this.Data.Push_Event_Msg("St2-2",This.Msg);
      --Liberar_Msg(Msg);
   exception
      when others =>
         print(true,"First_Activity--Execute_Tick--"& this.Get_Name &"--exception");

   end Execute_Tick;

--     ----------------
--     -- Set_Period --
--     ----------------
--
--     procedure Set_Period(This : in out First_Activity;Per : type_SA_Period) is
--     begin
--        null;
--     end Set_Period;
--
--     ----------------
--     -- Get_Period --
--     ----------------
--
--     function  Get_Period(This :First_Activity)return type_SA_Period is
--     begin
--        return 0;
--     end Get_Period;
--
--     -------------
--     -- Is_Done --
--     -------------
--
--     function Is_Done (This : First_Activity) return Boolean is
--     begin
--        return True;
--     end Is_Done;
--
--     --------------
--     -- Get_Name --
--     --------------
--
--     function  Get_Name (This :First_Activity) return string is
--     begin
--        return "Null_Activity";
--     end Get_Name;
--
--     --------------
--     -- Set_Name --
--     --------------
--
--     procedure Set_Name(This :in out First_Activity;str : string) is
--     begin
--        null;
--     end Set_Name;


end minfr.State_Activity.Leaf_Activity.First_Activity;
