with Minfr.MSG.Minfr_Msg,
     Minfr.MinFr_Component,
     Minfr.MinFr_Component_Data,
     Minfr.MinFr_Port;

use  Minfr.MSG.Minfr_Msg,
    Minfr.MinFr_Component,
    Minfr.MinFr_Component_Data,
    Minfr.MinFr_Port;


package Minfr.State_Activity.Leaf_Activity.State_Loop_C1_R2 is

   type State_Loop_C1_R2 (<>) is new Leaf_Activity with private;
   type Ptr_State_Loop_C1_R2 is access all State_Loop_C1_R2;

    ---------------------------Constructor-----------------------------
   not overriding
   function Constr_State_Loop_C1_R2 (Id :Id_State_Activity ; Component : Ptr_MinFr_Component) return Ptr_State_Loop_C1_R2;
   overriding
   procedure Execute_Tick (This :in out State_Loop_C1_R2);

private

   Debug : Boolean := false;

   type State_Loop_C1_R2 is new Leaf_Activity with record
      Component : Ptr_MinFr_Component;
      Data : Ptr_MinFr_Component_Data;
      Port_In :  Ptr_MinFr_Input_Port;
      Port_Out :  Ptr_MinFr_OutPut_Port;
      Msg : Ptr_Minfr_Msg := Constr_Minfr_Msg("MSG-Loop_C1_R2");
   end record;



end Minfr.State_Activity.Leaf_Activity.State_Loop_C1_R2;
