with Ada.Strings.Unbounded;

use Ada.Strings.Unbounded;

package minfr.State_Activity is



   type Id_State_Activity is new Natural;
   type type_SA_Period is new Natural;

   type State_Activity is interface;
   --type State_Activity is abstract tagged null record;
   type Ptr_State_Activity is access all State_Activity'Class;

   not overriding
   procedure Execute_Tick (This :in out State_Activity) is abstract;
   not overriding
   procedure Set_Period(This : in out State_Activity;Per : type_SA_Period) is abstract;
   not overriding
   function  Get_Period(This :State_Activity)return type_SA_Period is abstract;
   not overriding
   function  Is_Done(This :State_Activity) return boolean is abstract;
   not overriding
   function  Get_Name (This :State_Activity) return string is abstract;
   not overriding
   procedure Set_Name(This :in out State_Activity;str : string) is abstract;
   not overriding
   procedure Set_Id (This :in out State_Activity;id : Id_State_Activity) is abstract;
   not overriding
   function  Get_Id (This :State_Activity) return Id_State_Activity is abstract;
   not overriding
   procedure Execute_On_Entry (This :in out State_Activity) is abstract;
   not overriding
   procedure Execute_On_Exit(This :State_Activity)is abstract;
   not overriding
   procedure Set_Enable_State_Id (this : in out State_Activity;St_Id : in Id_State_Activity) is abstract;

end minfr.State_Activity;
