with Ada.Strings.Unbounded,
     Minfr.MinFr_Component_Data.MinFr_Data,
     Minfr.MSG.Minfr_Msg;


use Ada.Strings.Unbounded,
    Minfr.MinFr_Component_Data.MinFr_Data,
    Minfr.MSG.Minfr_Msg;

package minfr.Condition.Condition_C1 is

type Type_Cst_C1 is new Natural;

   type Condition_C1 (<>) is new Condition with private;
   type Ptr_Condition_C1 is access Condition_C1;

   not overriding
   function Constr_Condition_C1 (data : P_MinFr_Data; Event_Type : string; buffered : boolean)return Ptr_Condition_C1;
   overriding
   function Evaluate_Condition (this : Condition_C1) return boolean;


private

   type Condition_C1 is new Condition with record
      Event_Type : Unbounded_string :=Null_Unbounded_String; --Ristra de longitud Dinamica;
      Subs_Id : Type_Cst_C1;
      data : P_MinFr_Data;
      Last_Msg_Sec_Num : Type_Cst_C1;
      buffered : boolean;
   end record;


end minfr.Condition.Condition_C1;
