with minfr.Debug;
use minfr.Debug;

package body minfr.Minfr_State.Hierarchical_State.Region is

   function Constr_Region (data :  P_MinFr_Data; name : string; states : Vector_ptr_Minfr_State.Vector; id : State_Id; Component_Unique_Id : State_Id ) return Ptr_Region is
      tmp1 : Ptr_Hierarchical_State;
   begin
      return tmp :Ptr_Region do --Indicamos que es un putero de Region
         tmp:=new Region;  --Indicamos a la direcion que apunta
         tmp1 := Ptr_Hierarchical_State(tmp);
         Constr_Hierarchical_State (tmp1,data,id+Component_Unique_Id*1000);
         tmp.name := to_unbounded_string(name);
         tmp.My_Component_Data := data;

         print(debug,"Region--Constr_Region--states.Length = " & Index_Vector'Image( Index_Vector(states.Length)));
         Pulse_key (debug);

         for I in Index_Vector range 0 .. Index_Vector(states.Length)-1 loop
            tmp.My_States.Append(states.Element(I).Get_Id);
            print(debug,"Region--Constr_Region("& name &")-tmp.My_States.Append("& states.Element(I).Get_Name &").Get_Id("& State_Id'Image(states.Element(I).Get_Id) &"))");
            Pulse_key(debug);
            tmp.My_Component_Data.Register_State(states.Element(I));
            print(debug,"Region--Constr_Region("& name &")-tmp.My_Component_Data.Register_State("& states.Element(I).Get_Name &")");
            Pulse_key(debug);
         end loop;
         print(debug,"Region--Constr_Region("& name &")-tmp.My_Component_Data.Register_State("& Minfr_State_Ptr(tmp).Get_Name &")");
         Pulse_key(debug);
         tmp.My_Component_Data.Register_State(Minfr_State_Ptr(tmp));
         tmp.Next_St := states.Element(0).Get_Id;
         tmp.Current_St := tmp.Next_St;
      end return;
   end Constr_Region;



   procedure On_Entry (This : in out Region) is
   begin
      null;
   end On_Entry;


   procedure On_Exit (This : in out Region) is
   begin
      null;
   end On_Exit;


end minfr.Minfr_State.Hierarchical_State.Region;
