--with Ada.Containers.Vectors;
     --Minfr.MinFr_Component_Data.MinFr_Data;

--use Ada.Containers;
     --Minfr.MinFr_Component_Data.MinFr_Data;

package minfr.Minfr_State.Hierarchical_State.Region is

   --type Region (<>) is new Hierarchical_State and Minfr_State with private;
   type Region (<>) is new Hierarchical_State with private;
   type Ptr_Region is access Region;
   type Index_Vector is new Natural;

   package Vector_ptr_Minfr_State is new Vectors (Index_Vector,Minfr_State_Ptr);
   use Vector_ptr_Minfr_State;

   not overriding
   function Constr_Region (data :  P_MinFr_Data; name : string; states : Vector_ptr_Minfr_State.Vector; id : State_Id; Component_Unique_Id : State_Id ) return Ptr_Region;

   overriding
   procedure On_Entry (This : in out Region);
   overriding
   procedure On_Exit (This : in out Region);

private
   debug : boolean := False;
   type Region is new Hierarchical_State with null record;


end minfr.Minfr_State.Hierarchical_State.Region;
