with Ada.Containers.Indefinite_Ordered_Maps,
     Ada.Strings.Unbounded;

use Ada.Containers,
    Ada.Strings.Unbounded;

package minfr.MSG is

   --type Msg (<>) is tagged private;
   type Msg is abstract tagged private;
   type Ptr_Msg is access all Msg'Class;
---------Constructores----------
   --function Constr_Msg return access Msg;
   --function Constr_Msg (msg_Type : string) return access Msg;

   not overriding
   procedure set_Value(this:in out Msg; Key,value:string);
   not overriding
   procedure UpDate_Value(this:in out Msg;Key,value:String;Res :in out Boolean);
   not overriding
   function get_Msg_Type(this:in  Msg) return string;
   not overriding
   function get_Value(this:in  Msg;Key:string) return string;
   pragma  Inline (Set_Value,Get_Msg_Type,get_Value);


private
   Debug : Boolean := False;

   package Tabla is new Ada.Containers.Indefinite_Ordered_Maps
     (Key_Type => string,
      Element_Type => string,
      "<" => "<");
   use  tabla;

   type msg is abstract tagged record --Es abstract por que no se puede crear un objeto de esta clase pero de sus hijos si...
      msg_type : Unbounded_string :=Null_Unbounded_String; --Ristra de longitud Dinamica
      msg:Tabla.Map;
   end record;

   procedure set_Msg_Type(this:in out Msg; str : string);

end minfr.MSG;
