with Minfr.MSG.Minfr_Msg,
     Minfr.MinFr_Port,
     Minfr.MinFr_Component,
     Minfr.MinFr_Component_Data;

use Minfr.MSG.Minfr_Msg,
    Minfr.MinFr_Port,
    Minfr.MinFr_Component,
    Minfr.MinFr_Component_Data;


package Minfr.State_Activity.Leaf_Activity.First_Activity is

   type First_Activity (<>) is new Leaf_Activity with private;
   type Ptr_First_Activity is access all First_Activity;

    ---------------------------Constructor-----------------------------
   not overriding
   function Constr_First_Activity (Id :Id_State_Activity ; Component : Ptr_MinFr_Component) return Ptr_First_Activity;
   overriding
   procedure Execute_Tick (This :in out First_Activity);
--     overriding
--     procedure Set_Period(This : in out First_Activity;Per : type_SA_Period);
--     overriding
--     function  Get_Period(This :First_Activity)return type_SA_Period;
--     overriding
--     function  Is_Done(This :First_Activity) return boolean;
--     overriding
--     function  Get_Name (This :First_Activity) return string;
--     overriding
--     procedure Set_Name(This :in out First_Activity;str : string);

private

   Debug : Boolean := false;

   type First_Activity is new Leaf_Activity with record
      Component : Ptr_MinFr_Component;
      Data : Ptr_MinFr_Component_Data;
      Port_In :  Ptr_MinFr_Input_Port;
      Port_Out : Ptr_MinFr_OutPut_Port;
      Msg : Ptr_Minfr_Msg := Constr_Minfr_Msg("Msg");
   end record;



end Minfr.State_Activity.Leaf_Activity.First_Activity;
