with minfr.Debug,
     Ada.Exceptions;

use minfr.Debug,
    Ada.Exceptions;

package body Minfr.State_Activity.Leaf_Activity.State_Loop_C1_R2 is


   function Constr_State_Loop_C1_R2 (Id :Id_State_Activity ; Component : Ptr_MinFr_Component) return Ptr_State_Loop_C1_R2 is
      Ports : Pack_Orde_Maps_Port.Map;
      iter : Pack_Orde_Maps_Port.Cursor;
      debug : boolean := false;
   begin
      return Tmp : Ptr_State_Loop_C1_R2 do
         print(debug,"State_Loop_C1_R2--Constr_State_Loop_C1_R2");
         Pulse_key(debug);
         Tmp := new State_Loop_C1_R2;
         Tmp.Component := Component;
         Ports := Tmp.Component.Get_Ports;
         Tmp.Data := Ptr_MinFr_Component_Data(Component.Get_Component_Data);
         iter := Ports.Find(1001);
         Tmp.Port_In := Ptr_MinFr_Input_Port(Pack_Orde_Maps_Port.Element(iter));
         print(debug,"State_Loop_C1_R2--Constr_State_Loop_C1_R2--This.Port_In.Get_Name : " & Tmp.Port_In.Get_Name);
         Pulse_key(debug);
         iter := Ports.Find(1003);
         Tmp.Port_Out := Ptr_MinFr_OutPut_Port(Pack_Orde_Maps_Port.Element(iter));
         print(debug,"State_Loop_C1_R2--Constr_State_Loop_C1_R2--This.Port_Out.Get_Name : " & Tmp.Port_Out.Get_Name);
         Pulse_key(debug);
      end return;
   end Constr_State_Loop_C1_R2;


   procedure Execute_Tick (This :in out State_Loop_C1_R2) is
      Id : LastTable_Id:=0;
      Cont : Natural;
      debug : boolean := false;
      Bool : boolean := false;
   begin
      print(debug1,"State_Loop_C1_R2--Execute_Tick--" & this.Component.Get_Component_Name);
      Pulse_key(debug);

      bucle:
      loop
         if this.Data.Has_InPort_Msg (This.Port_In.Get_Name,Id) then
            print(debug1,"State_Loop_C1_R2--" & this.Get_Name &"--Execute_Tick--this.Data.Has_InPort_Msg(" & This.Port_In.Get_Name &"," & LastTable_Id'Image(Id) & ")");
            Pulse_key(debug);
            This.Msg.all := this.Data.Pop_InPort_Msg(This.Port_In.Get_Name,Id);
            if This.Msg.get_Value("Add") = "1" then
               print(True,this.Component.Get_Component_Name & "--" & this.Get_Name &"--Execute_Tick--Msg.Get_Value = " & This.Msg.Get_Value("Dato"));
               print_Fichero ("State_Loop_C1_R2.txt",this.Component.Get_Component_Name & "--" & this.Get_Name &"--Execute_Tick--Msg.Get_Value = " & This.Msg.Get_Value("Dato"),0);
               Pulse_key(debug);
               Cont := Natural'Value(This.Msg.Get_Value("Dato"))+1;
               if Cont > 1000 then
                  Cont := 0;
               end if;
               print(debug,this.Component.Get_Component_Name &"--State_Loop_C1_R2--" & this.Get_Name &"--Execute_Tick--Cont = " & Natural'Image(Cont));
               Pulse_key(debug);
               This.Msg.UpDate_Value("Dato",Natural'Image(Cont),Bool);
               print(debug,this.Component.Get_Component_Name &"--State_Loop_C1_R2--" & this.Get_Name &"--Execute_Tick--Msg.Value = " & This.Msg.get_Value("Dato"));
               Pulse_key(debug);
               this.Data.Push_OutPort_Msg(this.Port_Out.Get_Name,this.Msg);
            end if;
         else
            print(debug,"State_Loop_C1_R2--Has_InPort_Msg = FALSE");
            Pulse_key(debug);
            exit bucle;
         end if;
      end loop bucle;

      this.Data.Push_Event_Msg("C1-R2-St2-2",this.Msg);
      print(debug,"State_Loop_C1_R2--Execute_Tick--" & This.Component.Get_Component_Name & "--Fin--Estado--" & This.Get_Name);
      Pulse_key(debug);


      exception
      when Error: others =>
         print(true,"State_Loop_C1_R2--Execute_Tick--exception : " & Exception_Information(Error));
         Pulse_key(true);
   end Execute_Tick;


end Minfr.State_Activity.Leaf_Activity.State_Loop_C1_R2;
