with minfr.Debug;

use minfr.Debug;

package body Minfr.State_Activity.Leaf_Activity.State_Start_C1_R3 is


   function Constr_State_Start_C1_R3 (Id :Id_State_Activity ; Component : Ptr_MinFr_Component) return Ptr_State_Start_C1_R3 is
      tmp1 : Ptr_Leaf_Activity;
      Ports : Pack_Orde_Maps_Port.Map;
      iter : Pack_Orde_Maps_Port.Cursor;
      debug : boolean := false;
   begin
       return Tmp : Ptr_State_Start_C1_R3 do
         Tmp := new State_Start_C1_R3;
         tmp1 := Ptr_Leaf_Activity(Tmp);
         Constr_Leaf_Activity(Tmp1,Id);
         Tmp.Component := Component;
         Ports := Tmp.Component.Get_Ports;
         Tmp.Data := Component.Get_Component_Data;
         iter := Ports.Find(1002);
         Tmp.Port_In := Ptr_MinFr_Input_Port(Pack_Orde_Maps_Port.Element(iter));
         print(debug,"State_Start_C1_R3--Constr_State_Start_C1_R3--This.Port_In.Get_Name : " & Tmp.Port_In.Get_Name);
         Pulse_key(debug);
         iter := Ports.Find(1004);
         Tmp.Port_Out := Ptr_MinFr_OutPut_Port(Pack_Orde_Maps_Port.Element(iter));
         print(debug,"State_Start_C1_R3--Constr_State_Start_C1_R3--This.Port_Out.Get_Name : " & Tmp.Port_Out.Get_Name);
         Pulse_key(debug);
      end return;
   end Constr_State_Start_C1_R3;


   procedure Execute_Tick (This :in out State_Start_C1_R3) is
      Ports : Pack_Orde_Maps_Port.Map;
      debug : boolean := false;
      --Msg : Minfr_Msg;
      --Port : Ptr_MinFr_Port;
   begin
      print(debug,"State_Start_C1_R3--Execute_Tick--" & This.Component.Get_Component_Name);
      Pulse_key(debug);
      this.Msg.Set_Value("Dato","0");
      this.Msg.Set_Value("Add","5");
      this.Data.Push_OutPort_Msg(this.Port_Out.Get_Name,this.Msg);
      this.Data.Push_Event_Msg("C1-R3-St1-2",this.Msg);
      print(debug,"State_Start_C1_R3--Execute_Tick--" & This.Component.Get_Component_Name & "--Fin--Estado--" & This.Get_Name);
      Pulse_key(debug);
   end Execute_Tick;


end Minfr.State_Activity.Leaf_Activity.State_Start_C1_R3;
