with minfr.Debug;

use minfr.Debug;


package body minfr.State_Activity.Leaf_Activity.Cmd_Up_date is

   function Constr_Cmd_Up_date (Id : Id_State_Activity;Container_Component : Ptr_MinFr_Component;Data : Ptr_MinFr_Component_Data) return Ptr_Cmd_Up_date is
   begin
       return Tmp : Ptr_Cmd_Up_date do
         Tmp := new Cmd_Up_date;
         Tmp.My_Data := Data;
         Tmp.Container_Component := Container_Component;
      end return;
   end Constr_Cmd_Up_date;

    ------------------
   -- Execute_Tick --
    ------------------

   procedure Execute_Tick (This :in out Cmd_Up_date) is
      Ports : Pack_Orde_Maps_Port.Map;
      Port : Ptr_MinFr_Port;
      use Pack_Orde_Maps_Port;
      iter : Cursor;
      debug :boolean := false;
   begin

--         if this.Container_Component.Get_Component_Name = "Componente_2" then
--           print(true,"Debug_Bucle-Loop_TB");
--           Pulse_key(true);
--           Loop_TB;
--        end if;


      print(debug,"Cmd_Up_date--Execute_Tick--" & this.Container_Component.Get_Component_Name);
      Pulse_key(debug);
      Ports := this.Container_Component.Get_Ports;
      iter := Ports.First; ---Posicion del primer elemento de la hast-table
      if (iter /= No_Element) then
         print(debug,"Cmd_Up_date--Execute_Tick--" & this.Container_Component.Get_Component_Name & "--Hay datos en la Tabla");
         Pulse_key(debug);
         Bucle:
         loop
            Port := element(iter);
            print(debug,"Cmd_Up_date--Execute_Tick--Port.Get_Name: " & Port.Get_Name);
            Pulse_key(debug);
            if Port'Tag = Ptr_MinFr_Port(This.Out_Port)'Tag then
               print(debug,"Cmd_Up_date--Execute_Tick--" & this.Container_Component.Get_Component_Name & "--Tiene un puerto Out_Port");
               Pulse_key(debug);
               if This.My_Data.Has_OutPort_Msg(Port.Get_Name)then


                  print(debug,"Cmd_Up_date--Execute_Tick--" & this.Container_Component.Get_Component_Name & "--hay mensajes para enviar buffer de salida");

                  Pulse_key(debug);

                  This.msg.all := This.My_Data.Pop_OutPort_Msg(Port.Get_Name);

                  print(debug,"Cmd_Up_date--Execute_Tick--" & this.Container_Component.Get_Component_Name & "--Msg : " & This.msg.Get_Name);

                  Pulse_key(debug);

                  Port.UpDate(This.msg);

               end if;

            end if;

            next(iter);
            if iter = No_Element then
               print(debug,"Cmd_Up_date--Execute_Tick--" & this.Container_Component.Get_Component_Name & "iter = No_Element");
               Pulse_key(debug);
            else
               print(debug,"Cmd_Up_date--Execute_Tick--" & this.Container_Component.Get_Component_Name & "iter /= No_Element");
               Pulse_key(debug);
            end if;

            exit Bucle when (iter = No_Element);

         end loop Bucle;
      else
         print(debug,"Cmd_Up_date--Execute_Tick--" & this.Container_Component.Get_Component_Name & "--No hay Elementos");
         Pulse_key(debug);
      end if;


   end Execute_Tick;



end minfr.State_Activity.Leaf_Activity.Cmd_Up_date;
