with Ada.Tags,
     Ada.Containers.Ordered_Maps,
     Minfr.MSG.Minfr_Msg,
     Minfr.MinFr_Port,
     Minfr.MinFr_Component,
     Minfr.MinFr_Component_Data;

use Ada.Tags,
    Minfr.MSG.Minfr_Msg,
    Minfr.MinFr_Port,
    Minfr.MinFr_Component,
    Minfr.MinFr_Component_Data;

package minfr.State_Activity.Leaf_Activity.Cmd_Up_date is


   type Cmd_Up_date (<>) is new Leaf_Activity with private;
   type Ptr_Cmd_Up_date is access all Cmd_Up_date;



 ---------------------------Constructor-----------------------------
   not overriding
   function Constr_Cmd_Up_date (Id : Id_State_Activity;Container_Component : Ptr_MinFr_Component;Data : Ptr_MinFr_Component_Data) return Ptr_Cmd_Up_date;

   overriding
   procedure Execute_Tick (This :in out Cmd_Up_date);


private

   debug : boolean := false;
   type Cmd_Up_date is new Leaf_Activity with record
      Container_Component : Ptr_MinFr_Component;
      My_Data : Ptr_MinFr_Component_Data;
      Out_Port :  Ptr_MinFr_Output_Port := Constr_MinFr_Output_Port;
      msg : Ptr_Minfr_Msg := Constr_Minfr_Msg;
   end record;

end minfr.State_Activity.Leaf_Activity.Cmd_Up_date;
