package minfr.State_Activity.Leaf_Activity is


   --type Leaf_Activity (<>) is new State_Activity with private;
   type Leaf_Activity is abstract new State_Activity with private;
   type Ptr_Leaf_Activity is access all Leaf_Activity;



 ---------------------------Constructor-----------------------------
   not overriding
   --function Constr_Leaf_Activity (Id :Id_State_Activity) return Ptr_Leaf_Activity;
   procedure Constr_Leaf_Activity (tmp :in out Ptr_Leaf_Activity; Id :Id_State_Activity);
   not overriding
   --function Constr_Leaf_Activity return Ptr_Leaf_Activity;
   procedure Constr_Leaf_Activity(tmp :in out Ptr_Leaf_Activity);

   overriding
   procedure Execute_Tick (This :in out Leaf_Activity);
   overriding
   procedure Set_Period(This : in out Leaf_Activity;Per : type_SA_Period);
   overriding
   function  Get_Period(This :Leaf_Activity)return type_SA_Period;
   overriding
   function  Is_Done(This :Leaf_Activity) return boolean;
   not overriding
   procedure Set_Done(This : in out Leaf_Activity);
   overriding
   function  Get_Name (This :Leaf_Activity) return string;
   overriding
   procedure Set_Name(This :in out Leaf_Activity;str : string);
   overriding
   procedure Set_Id (This :in out Leaf_Activity;id : Id_State_Activity);
   overriding
   function  Get_Id (This :Leaf_Activity) return Id_State_Activity;
   overriding
   procedure Execute_On_Entry (This :in out Leaf_Activity);
   overriding
   procedure Execute_On_Exit(This :Leaf_Activity);
   overriding
   procedure Set_Enable_State_Id (this : in out Leaf_Activity;St_Id : in Id_State_Activity);

private

   debug : boolean := False;

   type Leaf_Activity is abstract new State_Activity with record
      Name : Unbounded_String;
      done : boolean;
      id : Id_State_Activity;
      T : type_SA_Period;
   end record;

end minfr.State_Activity.Leaf_Activity;
