with minfr.Debug,
     minfr.MinFr_Port;

use minfr.Debug,
    minfr.MinFr_Port;

package body Minfr.State_Activity.Leaf_Activity.Start_Activity is


   function Constr_Start_Activity (Id :Id_State_Activity ; Component : Ptr_MinFr_Component) return Ptr_Start_Activity is
      tmp1 : Ptr_Leaf_Activity;
   begin
       return Tmp : Ptr_Start_Activity do
         Tmp := new Start_Activity;
         tmp1 := Ptr_Leaf_Activity(Tmp);
         Constr_Leaf_Activity(Tmp1,Id);
         Tmp.Component := Component;
         Tmp.Data := Component.Get_Component_Data;
         Tmp.Msg := Constr_Minfr_Msg("Msg");
      end return;
   end Constr_Start_Activity;


   procedure Execute_Tick (This :in out Start_Activity) is
      Ports : Pack_Orde_Maps_Port.Map;
      id_Port_out : Port_ID := 1001;
      Port : Ptr_MinFr_Port;
   begin
      print(debug,this.Component.Get_Component_Name &"--Start_Activity--"& this.Get_Name &"--Execute_Tick--Start_Activity");
      Pulse_key(debug);

      this.Msg.Set_Value("Dato","0");

      Ports := this.Component.Get_Ports;

      Port := Ports.Element(Key_Type_Map(id_Port_out));

      print(debug,this.Component.Get_Component_Name & "--Start_Activity--" & this.Get_Name &"--Execute_Tick--"& Port.Get_Name &".UpDate(Msg_send.all)");
      Pulse_key(debug);

      Port.UpDate(this.Msg);

        this.Data.Push_Event_Msg("St1-2",this.Msg);
--        Pulse_key(debug);
   end Execute_Tick;


end Minfr.State_Activity.Leaf_Activity.Start_Activity;
